/**********************************************/
/* class for the infrared sensor controlling. */
/* file: InfraredSensor.h                     */
/* Author: Th. Kaffka, Cologne, Germany       */
/* Date: 04/12/2016                           */
/**********************************************/

#ifndef InfraredSensor_h
#define InfraredSensor_h

#include "Arduino.h"

class InfraredSensor {

  private:
  int analog_pin;
  float twoPointForm(float x, float x1, float y1, float x2, float y2); 

  public:
  InfraredSensor(int ppin);
  long read(); 
  float distance(); 
};

InfraredSensor::InfraredSensor(int ppin) {
  analog_pin = ppin;
}

long InfraredSensor::read() {
  return analogRead(analog_pin);
}

float InfraredSensor::distance() {
  return twoPointForm(read(), 490, 3, 200, 14);
}

float InfraredSensor::twoPointForm(float x, float x1, float y1, float x2, float y2) {
   return y1 + (y2 - y1) / (x2 - x1) * (x - x1);
}

#endif