/**********************************************/
/* class for the led controlling.             */
/* file: Led.h                                */
/* Author: Th. Kaffka, Cologne, Germany       */
/* Date: 02/29/2016                           */
/**********************************************/

#ifndef Led_h
#define Led_h

#include "Arduino.h"

class Led {
  private:
  int pin_number;

  public:
  Led(int ppin_number);
  void ledOn();
  void ledOff();
  void ledDim(int pmw_value);
};

Led::Led(int ppin_number) {
  pin_number = ppin_number;
  pinMode(pin_number, OUTPUT);
}

void Led::ledOn() {
  digitalWrite(pin_number, HIGH);
}

void Led::ledOff() {
  digitalWrite(pin_number, LOW);
}

void Led::ledDim(int pmw_value) {
  analogWrite(pin_number, pmw_value);
}

#endif