/**********************************************/
/* class for the neural network.              */
/* file: NeuralNetwork.h                      */
/* Author: Th. Kaffka, Cologne, Germany       */
/* Date: 09/02/2016                           */
/**********************************************/

#ifndef NeuralNetwork_h
#define NeuralNetwork_h

#include "Arduino.h"

#define x_columns 2 // the x layer.
#define y_columns 2 // the y layer.
#define nh 6 // teh hidden layer.

class NeuralNetwork {
  private:
  float epsilon;
  float factor;
  float x[x_columns + 1];
  float y[y_columns];
  float h[nh + 1];
  float w1[x_columns + 1][nh + 1];
  float w2[nh + 1][y_columns];
  float t(float a);
  void execute();

  public:
  NeuralNetwork(float pepsilon, float pfactor);
  float* executeFunction(float px[x_columns]);
};

NeuralNetwork::NeuralNetwork(float pepsilon, float pfactor) {
	x[x_columns] = 1.0f;
    epsilon = pepsilon;
	h[nh] = 1.0f;
    factor = pfactor;

    // fill the w1 array begin.

    // fill the w1 array end.


    // fill the w2 array begin.

    // fill the w2 array end.

}

float NeuralNetwork::t(float a) {
  return 1.0f / (1.0f + exp(-a));
}

void NeuralNetwork::execute() {
    for (int k=0;k<nh;k++) {
        float a = 0.0;
        for (int i=0;i<x_columns + 1;i++) {
            a += w1[i][k] * x[i];
		}
        h[k] = t(a);
	}
    for (int j=0;j<y_columns;j++) {
        float a = 0.0;
        for (int k=0;k<nh + 1;k++) {
            a += w2[k][j] * h[k];
		}
        y[j] = t(a);
	}
}

float* NeuralNetwork::executeFunction(float px[x_columns]) {
    for (int i=0;i<x_columns;i++) {
		x[i] = px[i] * factor;
		if (x[i] > 1.0f) {
			x[i] = 0.99;
		}
	}
	execute();
	float *result = new float[y_columns];
    for (int j=0;j<y_columns;j++) {
		result[j] = y[j] / factor;
	}
    return result;
}

#endif