/**********************************************/
/* class for the touch sensor controlling.    */
/* file: TouchSensor.h                        */
/* Author: Th. Kaffka, Cologne, Germany       */
/* Date: 03/02/2016                           */
/**********************************************/

#ifndef TouchSensor_h
#define TouchSensor_h

#include "Arduino.h"

class TouchSensor {

  private:
  int pin;

  public:
  TouchSensor(int ppin);
  byte isTouch(); 
};

TouchSensor::TouchSensor(int ppin) {
  pin = ppin;
  pinMode(pin, INPUT);
  digitalWrite(pin, HIGH); // activate the pull up resistor. 
}

byte TouchSensor::isTouch() {
  int data = digitalRead(pin);
  delay(40);
  if (data == HIGH) {
    return false;
  }
  return true;
}

#endif