/************************************************/
/* class for the ultrasonic sensor controlling. */
/* file: UltrasonicSensor.h                     */
/* Author: Th. Kaffka, Cologne, Germany         */
/* Date: 04/12/2016                             */
/************************************************/

#ifndef UltrasonicSensor_h
#define UltrasonicSensor_h

#include "Arduino.h"

class UltrasonicSensor {

  private:
  int trig_pin;
  int echo_pin;

  public:
  UltrasonicSensor(int trgp, int ecop);
  long timing(); 
  long ranging(); 
};

UltrasonicSensor::UltrasonicSensor(int trgp, int ecop) {
  trig_pin = trgp;
  echo_pin = ecop;
  pinMode(trig_pin, OUTPUT);
  pinMode(echo_pin, INPUT);
}

long UltrasonicSensor::timing() {
  digitalWrite(trig_pin, LOW);
  delayMicroseconds(2);
  digitalWrite(trig_pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig_pin, LOW);
  long duration = pulseIn(echo_pin, HIGH);
  if ((duration == 0) && digitalRead(echo_pin)) {
    pinMode(echo_pin, OUTPUT);
    digitalWrite(echo_pin, LOW);
    delay(100); 
    pinMode(echo_pin, INPUT);
  }  
  return duration;
}

long UltrasonicSensor::ranging() {
  long distance = timing() / 29 / 2;
  return distance;
}

#endif