/**********************************************/
/* functions for sound making.                */
/* file: sound.c                              */
/* Author: Th. Kaffka, Cologne, Germany       */
/* Date: 02/27/2016                           */
/**********************************************/

#ifndef Sound_h
#define Sound_h

#include "Arduino.h"

#define TONE_B5 988
#define TONE_A5 880
#define TONE_G5 784
#define TONE_F5 698
#define TONE_E5 659
#define TONE_D5 587
#define TONE_C5 523
#define TONE_B4 494
#define TONE_A4 440
#define TONE_G4 392
#define TONE_F4 349
#define TONE_E4 330
#define TONE_D4 294
#define TONE_C4 262
#define TONE_B3 247
#define TONE_A3 220
#define TONE_G3 196
#define TONE_F3 175
#define TONE_E3 165
#define TONE_D3 145
#define TONE_C3 131

static void beepMessageReady(int pin) {
   tone (pin, TONE_C4);
   delay(100);
   tone (pin, TONE_F4);
   delay(200);
   tone (pin, TONE_E4);
   delay(100);
   tone (pin, TONE_G4);
   delay(300);
   noTone(pin);
}

static void beepMessageEnd(int pin) {
   tone (pin, TONE_G4);
   delay(100);
   tone (pin, TONE_A4);
   delay(250);
   noTone(pin);
   delay(50);
   tone (pin, TONE_A4);
   delay(250);
   tone (pin, TONE_E4);
   delay(300);
   noTone(pin);
}

static void beepMessageError(int pin) {
   tone (pin, TONE_A3);
   delay(400);
   tone (pin, TONE_F3);
   delay(250);
   tone (pin, TONE_A3);
   delay(800);
   noTone(pin);
}

static void beepMessageOk(int pin) {
   tone (pin, TONE_C5);
   delay(200);
   tone (pin, TONE_F5);
   delay(350);
   tone (pin, TONE_C5);
   delay(150);
   noTone(pin);
}

static void beepMessageAknowledge(int pin) {
   tone (pin, TONE_G5);
   delay(300);
   tone (pin, TONE_C5);
   delay(200);
   noTone(pin);
}

static void beepMessageDataout(int pin) {
   tone (pin, TONE_G5);
   delay(150);
   noTone(pin);
   delay(150);
   tone (pin, TONE_G5);
   delay(150);
   tone (pin, TONE_C5);
   delay(300);
   noTone(pin);
}

#endif