/*********************************************/
/* Program morses a text.                    */
/* file: Morse.ino                           */
/* Author: Th. Kaffka, Cologne, Germany      */
/* Date: 03/04/2016                          */
/*********************************************/

#include <C:\_Thomas\Ae\C\Roboter\Interface\Led.h> // adjust this path.
#include <C:\_Thomas\Ae\C\Roboter\Interface\sound.h> // adjust this path.

const int SOUND_PIN = 3;
const int STR_LEN = 20;

Led led = Led(2);

char morse_alphabet[26][5] = {{'.', '-', '\0', '\0', '\0'},
                             {'-', '.', '.', '.', '\0'},
                             {'-', '.', '-', '.', '\0'},
                             {'-', '.', '.', '\0', '\0'},
                             {'.', '\0', '\0', '\0', '\0'},
                             {'.', '.', '-', '.', '\0'},
                             {'-', '-', '.', '\0', '\0'},
                             {'.', '.', '.', '.', '\0'},
                             {'.', '.', '\0', '\0', '\0'},
                             {'.', '-', '-', '-', '\0'},
                             {'-', '.', '-', '\0', '\0'},
                             {'.', '-', '.', '.', '\0'},
                             {'-', '-', '\0', '\0', '\0'},
                             {'-', '.', '\0', '\0', '\0'},
                             {'-', '-', '-', '\0', '\0'},
                             {'.', '-', '-', '.', '\0'},
                             {'-', '-', '.', '-', '\0'},
                             {'.', '-', '.', '\0', '\0'},
                             {'.', '.', '.', '\0', '\0'},
                             {'-', '\0', '\0', '\0', '\0'},
                             {'.', '.', '-', '\0', '\0'},
                             {'.', '.', '.', '-', '\0'},
                             {'.', '-', '-', '\0', '\0'},
                             {'-', '.', '.', '-', '\0'},
                             {'-', '.', '-', '-', '\0'},
                             {'-', '-', '.', '.', '\0'}
                            };


boolean read_string = false;

void resetString(char *text) {
  for (int i=0; i<STR_LEN; i++) {
    text[i] = '\0';
  }
}

void morseText(char* text) {
  char morse_text[5];
  for (int i=0; i<STR_LEN; i++) {
    
    if (text[i] != '\0') {

      // get the character code.
      char char_no = text[i] - 97;
      if (text[i] == ' ') {
        morse_text[0] = 'x';
      } else if (char_no < 0 || char_no > 25) {
        continue;
      } else {
        morse_text[0] = morse_alphabet[char_no][0];
        morse_text[1] = morse_alphabet[char_no][1];
        morse_text[2] = morse_alphabet[char_no][2];
        morse_text[3] = morse_alphabet[char_no][3];
        morse_text[4] = morse_alphabet[char_no][4];
      }

      // morse the character.
      for (int x=0; x<5; x++) {
        if (morse_text[x] == '.') {
          led.ledOn();
          tone (SOUND_PIN, TONE_C5);
          delay(100);
          led.ledOff();
          noTone(SOUND_PIN);
          delay(100);
        } else if (morse_text[x] == '-') {
          led.ledOn();
          tone (SOUND_PIN, TONE_C5);
          delay(300);
          led.ledOff();
          noTone(SOUND_PIN);
          delay(100);
        } else if (morse_text[x] == 'x') {
          delay(500);
          break;
        } else if (morse_text[x] == '\0') {
          break;
        }
      }
      delay(700);
    }
  }  
}

void setup() {
  Serial.begin(9600);
}

void loop() {
  if (!read_string) {
    Serial.println("Bitte gebe einen zu morsenden Text ein:");
    read_string = true;
  }
  
  if (read_string && Serial.available()) {
    char get_string[STR_LEN];
    int i = 0;
    resetString(get_string);
    while (Serial.available()) {
      char get_char = Serial.read();
      get_string[i] = get_char;
      delay(2);
      i++;
      if (i == STR_LEN-1) {
        break;
      }
    }
    
    delay(1000);
    morseText(get_string);
    read_string = false;
  }
}
