/*********************************************/
/* Program controls the gear motors.         */
/* file: MotorEncoder.ino                    */
/* Author: Th. Kaffka, Cologne, Germany      */
/* Date: 02/28/2016                          */
/*********************************************/

const int PMWA = 3;
const int AIN1 = 4;
const int AIN2 = 5;
const int ENCA = 6;

const int PMWB = 9;
const int BIN1 = 10;
const int BIN2 = 11;
const int ENCB = 12;

byte count_status_left = false;
byte count_status_right = false;
unsigned short int count_left = 0;
unsigned short int count_right = 0;

void setup() {
  Serial.begin(9600);
  
  pinMode(PMWA, OUTPUT);
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(ENCA, INPUT);
  digitalWrite(ENCA, HIGH); // activate the pull up resistor. 
  
  pinMode(PMWB, OUTPUT);
  pinMode(BIN1, OUTPUT);
  pinMode(BIN2, OUTPUT);
  pinMode(ENCB, INPUT);
  digitalWrite(ENCB, HIGH); // activate the pull up resistor. 

  analogWrite(PMWA, 64);
  digitalWrite(AIN1, HIGH);
  analogWrite(PMWB, 25);
  digitalWrite(BIN1, HIGH);
}

void loop() {
    int data_a = digitalRead(ENCA);
    int data_b = digitalRead(ENCB);

    // toggle and count.
    if (!count_status_left && (data_a == HIGH)) {
      count_status_left = true;
      count_left++;
    }
    if (count_status_left && (data_a == LOW)) {
      count_status_left = false;
      count_left++;
    }
    if (!count_status_right && (data_b == HIGH)) {
      count_status_right = true;
      count_right++;
    }
    if (count_status_right && (data_b == LOW)) {
      count_status_right = false;
      count_right++;
    }

    // send the counter values to the serail monitor.
    char str_left[5];
    itoa (count_left, str_left, 10);
    char str_right[5];
    itoa (count_right, str_right, 10);

    char str_out[12];
    str_out[0] = '\0';
    strcat (str_out, str_left);
    strcat (str_out, " ");
    strcat (str_out, str_right);

    Serial.println(str_out);

    // stop the program.
    if (count_left >= 500) {
      digitalWrite(AIN1, LOW);
      digitalWrite(BIN1, LOW);
      while(true) {
        delay(1000);
      }
    }

}
