/*********************************************/
/* Program controls the gear motors.         */
/* file: MotorEncoderClass.ino               */
/* Author: Th. Kaffka, Cologne, Germany      */
/* Date: 02/28/2016                          */
/*********************************************/

#include <C:\_Thomas\Ae\C\Roboter\Interface\GearMotor.h> // adjust this path.

const int PMWA = 5;
const int AIN1 = 7;
const int AIN2 = 8;
const int ENCA = 2;

const int PMWB = 6;
const int BIN1 = 9;
const int BIN2 = 10;
const int ENCB = 3;

GearMotor motor_a(PMWA, AIN1, AIN2, ENCA); 
GearMotor motor_b(PMWB, BIN1, BIN2, ENCB); 

void setup() {
  Serial.begin(9600);
  motor_a.setSpeed(64); 
  motor_b.setSpeed(25); 
  resetEncoderCountA();
  resetEncoderCountB();
  motor_a.forward();
  motor_b.forward();
}

void loop() {

    Serial.print(getEncoderCountA());
    Serial.print(" ");
    Serial.println(getEncoderCountB());

    // stop the program.
    if (getEncoderCountA() >= 500) {
      motor_a.stop();
    }
    if (getEncoderCountB() >= 500) {
      motor_b.stop();
    }

}
