/*********************************************/
/* Program controls a ultrasonic sensor.     */
/* file: UltrasonicSensor.ino                */
/* Author: Th. Kaffka, Cologne, Germany      */
/* Date: 04/12/2016                          */
/*********************************************/

const int TRIG_PIN = 12;
const int ECHO_PIN = 11;

void setup() {
  Serial.begin(9600);
  pinMode(TRIG_PIN, OUTPUT);
  pinMode(ECHO_PIN, INPUT);
}

void loop() {
  Serial.println(ranging());
  delay(100);
}

long timing() {
  digitalWrite(TRIG_PIN, LOW);
  delayMicroseconds(2);
  digitalWrite(TRIG_PIN, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG_PIN, LOW);
  long duration = pulseIn(ECHO_PIN, HIGH);
  if ((duration == 0) && digitalRead(ECHO_PIN)) {
    pinMode(ECHO_PIN, OUTPUT);
    digitalWrite(ECHO_PIN, LOW);
    delay(100); 
    pinMode(ECHO_PIN, INPUT);
  }  
  return duration;
}

long ranging() {
  long distance = timing() / 29 / 2;
  return distance;
}
