#!C:\Users\Thomas\AppData\Local\Programs\Python\Python35-32\python
import RPi.GPIO as GPIO

########################################
# class GearMotor                      #
# file: GearMotor.py                   #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 02/25/2016                     #
########################################

class GearMotor:

   def __init__(self, pmw, in1, in2, encoder=0):
      GPIO.setmode(GPIO.BOARD)
      GPIO.setup(pmw, GPIO.OUT)
      GPIO.setup(in1, GPIO.OUT)
      GPIO.setup(in2, GPIO.OUT)
      self.in1 = in1
      self.in2 = in2
      self.motor = GPIO.PWM(pmw, 100)
      self.motor.start(0)
      self.count = 0
      self.is_moving = False
      self.encoder = 0
      if (encoder != 0):
         self.encoder = encoder
         GPIO.setup(encoder, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
         GPIO.add_event_detect(encoder, GPIO.BOTH)
         GPIO.add_event_callback(encoder, self.encoderCount)

   def __del__(self):
      GPIO.output(self.in1, GPIO.LOW) 
      GPIO.output(self.in2, GPIO.LOW) 
      
   def forward(self):
      self.is_moving = True
      GPIO.output(self.in1, GPIO.HIGH) 
      GPIO.output(self.in2, GPIO.LOW) 

   def backward(self):
      self.is_moving = True
      GPIO.output(self.in1, GPIO.LOW) 
      GPIO.output(self.in2, GPIO.HIGH) 

   def setSpeed(self, speed):
      self.motor.ChangeDutyCycle(speed)      

   def stop(self):
      GPIO.output(self.in1, GPIO.HIGH) 
      GPIO.output(self.in2, GPIO.HIGH)
      self.is_moving = False

   def isMoving(self):
      return self.is_moving

   def encoderCount(self, pin):
      self.count += 1

   def resetEncoderCount(self):
      self.count = 0

   def getEncoderCount(self):
      return self.count
