#!/usr/bin/python3
import RPi.GPIO as GPIO
import time

########################################
# class UltrasonicSensor               #
# file: UltrasonicSensor.py            #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 04/16/2016                     #
########################################

class UltrasonicSensor:

   def __init__(self, tpin, epin):
      self.trig_pin = tpin
      self.echo_pin = epin
      GPIO.setmode(GPIO.BOARD)
      GPIO.setup(self.trig_pin, GPIO.OUT)
      GPIO.setup(self.echo_pin, GPIO.IN)

   def __del__(self):
      pass 

   def distance(self):
      GPIO.output(self.trig_pin, True)
      time.sleep(0.00001)
      GPIO.output(self.trig_pin, False)

      start_time = time.time()
      stop_time = time.time()

      while GPIO.input(self.echo_pin) == 0:
         start_time = time.time()

      while GPIO.input(self.echo_pin) == 1:
         stop_time = time.time()

      time_elapsed = stop_time - start_time
      dist = (time_elapsed * 34300) / 2
      return dist
