#!/usr/bin/python3
import sys
sys.path.append("/home/pi/Ae/Python/Roboter/Interface")
import RPi.GPIO as GPIO
import time
import os
from GearMotor import GearMotor
from Led import Led
from TouchSensor import TouchSensor
from PiezoSpeaker import PiezoSpeaker

####################################################
# Program controlls a dinner tray by php.          #
# file: DinnerTrayPhp.py                           #
# Author: Th. Kaffka, Cologne, Germany             #
# Date: 06/26/2016                                 #
####################################################

SPEED_FWD = 18 # motor speed forward.

PMWA = 40 
AIN2 = 38
AIN1 = 36
ENCA = 32

PMWB = 37 
BIN1 = 35
BIN2 = 33
ENCB = 31

motor_left = GearMotor(PMWA, AIN2, AIN1, ENCA)
motor_right = GearMotor(PMWB, BIN1, BIN2, ENCB)

button = TouchSensor(11)
led = Led(13)
speaker = PiezoSpeaker(15)

STOP = 0
GO = 1

LEFT = 0
STRAIGHT = 1
RIGHT = 2

start = True
led_on = False

onoff = STOP
leftright = STRAIGHT
motor_left.setSpeed(SPEED_FWD)
motor_right.setSpeed(SPEED_FWD)

speaker.beepMessageReady()

try:

   while(True):
      if (start and button.isTouch()):
         start = False
         led.ledOff()
         speaker.beepMessageOk()
         time.sleep(3)
         continue
      elif(start):
         led_on = not led_on
         if (led_on):
            led.ledOn()
         else:
            led.ledOff()
         time.sleep(0.5)
         continue
      elif ((not start) and button.isTouch()):
         start = True
         f.close()
         motor_left.stop()
         motor_right.stop()
         speaker.beepMessageOk()
         continue

      # look for command straight.
      try:
         f = open ("./cmd/straight.txt", "r")
         motor_left.forward()
         motor_right.forward()
         f.close()
         os.remove("./cmd/straight.txt")
      except FileNotFoundError:
         pass

      # look for command stop.
      try:
         f = open ("./cmd/stop.txt", "r")
         motor_left.stop()
         motor_right.stop()
         f.close()
         os.remove("./cmd/stop.txt")
      except FileNotFoundError:
         pass

      # look for command left.
      try:
         f = open ("./cmd/left.txt", "r")
         motor_left.backward()
         motor_right.forward()
         f.close()
         os.remove("./cmd/left.txt")
      except FileNotFoundError:
         pass

      # look for command right.
      try:
         f = open ("./cmd/right.txt", "r")
         motor_left.forward()
         motor_right.backward()
         f.close()
         os.remove("./cmd/right.txt")
      except FileNotFoundError:
         pass

      time.sleep(0.1)

except KeyboardInterrupt:
   pass
finally:
   motor_left.stop()
   motor_right.stop()
   GPIO.cleanup()


