#!/usr/bin/python3
import sys
sys.path.append("/home/pi/Ae/Python/Roboter/Interface")
import RPi.GPIO as GPIO
import time
from GearMotor import GearMotor
from Vehicle import Vehicle
from Led import Led
from TouchSensor import TouchSensor
from PiezoSpeaker import PiezoSpeaker
from LCDST7735 import *
from random import randint

####################################################
# Program avoid obstacles.                         #
# file: Touch.py                                   #
# Author: Th. Kaffka, Cologne, Germany             #
# Date: 04/05/2016                                 #
####################################################

PMWA = 40 
AIN2 = 38
AIN1 = 36
ENCA = 32

PMWB = 37 
BIN1 = 35
BIN2 = 33
ENCB = 31

button = TouchSensor(11)
led = Led(13)
speaker = PiezoSpeaker(15)
bumper_left = TouchSensor(7)
bumper_right = TouchSensor(29)

motor_a = GearMotor(PMWA, AIN2, AIN1, ENCA)
motor_b = GearMotor(PMWB, BIN1, BIN2, ENCB)
vehicle = Vehicle(4.2, 17.5, motor_a, motor_b)

DC = 18 # pin for sending data / command.
RES = 22 # pin for hardware reset.
disp = LCDST7735(DC, RES)

start = True
led_on = False

disp.clearScreen()
disp.setCursor(0, 24)
disp.setTextColorBoth(WHITE)
disp.setTextSize(2)
disp.setTextWrap(False)
disp.drawString("Touch")
disp.fillRect2(0, 40, disp.WIDTH, 16, RED)

speaker.beepMessageReady()

try:

   while(True):
      if (start and button.isTouch()):
         start = False
         led.ledOff()
         speaker.beepMessageOk()
         time.sleep(3)
         vehicle.forward()
         vehicle.setSpeed(25)
         continue
      elif(start):
         led_on = not led_on
         if (led_on):
            led.ledOn()
         else:
            led.ledOff()
         time.sleep(0.5)
         continue
      elif ((not start) and button.isTouch()):
         vehicle.stop()
         start = True
         speaker.beepMessageOk()
         continue

      if (bumper_left.isTouch() or bumper_right.isTouch()):
         vehicle.stop()
         if (bumper_left.isTouch()):
            disp.setCursor(0, 40)
            disp.drawString("bp: left")
         if (bumper_right.isTouch()):
            disp.setCursor(0, 40)
            disp.drawString("bp: right")

         distance = randint(5, 15)
         vehicle.backward(distance)
         time.sleep(0.5)
         angle = randint(0, 270) - 135
         time.sleep(0.5)
         vehicle.rotate(angle)
         disp.fillRect2(0, 40, disp.WIDTH, 16, RED)
         vehicle.forward()
         

except KeyboardInterrupt:
   pass
finally:
   GPIO.cleanup()


