#!C:\Users\Thomas\AppData\Local\Programs\Python\Python35-32\python
import sys
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations

########################################
# class hitechnic compass              #
# file: HitechnicCompassSensor.py      #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 01/26/2016                     #
########################################

class HitechnicCompassSensor:

   COMMAND = 0x41
   BEGIN_CALIBRATION = 0x43
   END_CALIBRATION = 0x00
   
   def __init__(self, port, speed, dev):
      self.port = port
      self.device = dev
      BrickPi.SensorType       [port]    = TYPE_SENSOR_I2C#Set the type of sensor at PORT_3
      BrickPi.SensorI2CSpeed   [port]    = speed          #Set the speed of communication
      BrickPi.SensorI2CDevices [port]    = 1              #number of devices in the I2C bus
      BrickPiSetup()  										# setup the serial port for communication
      BrickPi.SensorSettings   [port][self.device] = 0
      BrickPi.SensorI2CAddr    [port][self.device] = 0b00000010 #address for writing

   def getDirection(self):
      BrickPi.SensorI2CWrite [self.port][self.device]    = 1       #number of bytes to write
      BrickPi.SensorI2CRead  [self.port][self.device]    = 2       #number of bytes to read
      BrickPi.SensorI2COut   [self.port][self.device][0] = 0x42
      if not BrickPiUpdateValues():
         if (BrickPi.Sensor[self.port] & (0x01 << self.device)):
            buff0 = BrickPi.SensorI2CIn[self.port][self.device][0]
            buff1 = BrickPi.SensorI2CIn[self.port][self.device][1]
            return ((buff0 & 0xFF) << 1) + buff1
      return -1

   def startCalibration (self):
      BrickPi.SensorI2CWrite [self.port][self.device]    = 2       #number of bytes to write
      BrickPi.SensorI2CRead  [self.port][self.device]    = 0       #number of bytes to read
      BrickPi.SensorI2COut   [self.port][self.device][0] = self.COMMAND
      BrickPi.SensorI2COut   [self.port][self.device][1] = self.BEGIN_CALIBRATION
      if BrickPiUpdateValues() :
         print("start c. update values faild.")
         sys.exit(0)
      if not (BrickPi.Sensor[self.port] & (0x01 << self.device)) :
         print("start c. i2c communication faild.")
         sys.exit(0)

   def stopCalibration (self):
      BrickPi.SensorI2CWrite [self.port][self.device]    = 2       #number of bytes to write
      BrickPi.SensorI2CRead  [self.port][self.device]    = 0       #number of bytes to read
      BrickPi.SensorI2COut   [self.port][self.device][0] = self.COMMAND
      BrickPi.SensorI2COut   [self.port][self.device][1] = self.END_CALIBRATION
      if BrickPiUpdateValues() :
         print("stop c. update values faild.")
         sys.exit(0)
      if not (BrickPi.Sensor[self.port] & (0x01 << self.device)) :
         print("stop c. i2c communication faild.")
         sys.exit(0)
