#!/usr/bin/python
import io
import time
import picamera
from PIL import Image

########################################
# class rasprberry pi cmarea module    #
# file: RPiCamera.py                   #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 04/23/2016                     #
########################################

class RPiCamera:

   def __init__(self):
      self.cam = picamera.PiCamera()
      self.cam.hflip = True
      self.cam.vflip = True
      self.cam.image_effect = "posterise"
      self.setResolution(1024, 768)
      time.sleep(2)

   def __del__(self):
      self.cam.close()
      
   def setResolution(self, w, h):
      self.cam.resolutiuon = (w, h)

   def capture(self, w, h):
      stream = io.BytesIO()
      self.cam.capture(stream, format="bmp", resize=(w, h))
      stream.seek(0)
      return stream

   def captureList(self, w, h):
      stream = self.capture(w, h)
      image = Image.open(stream)
      return list(image.getdata())
