#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
from UpdateValues import *
import RPi.GPIO as GPIO
# import classes here.
from HitechnicCompassSensor import HitechnicCompassSensor
from Led import Led

###################################################
# program hitechnic compass sensor initialization #
# file: HitechnicCompassSensorInit.py             #
# Author: Th. Kaffka, Cologne, Germany            #
# Date: 05/15/2016                                #
###################################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
compass = HitechnicCompassSensor(PORT_4, 0, 0) # adjust the port !!!
left_led = Led(12)
right_led = Led(13)

BrickPiSetupSensors()

# global valibales.

####################
# led signal: go on.
def signalGo():
   left_led.ledOn();
   right_led.ledOn();
   time.sleep(0.1)
   left_led.ledOff();
   right_led.ledOff();
   time.sleep(0.1)

try:

   signalGo()
   compass.startCalibration()
   print("cancel loop by pressing Strg + C")
   while (True):
      time.sleep(0.04)
      
except KeyboardInterrupt:
   compass.stopCalibration()
   signalGo()
finally:
   left_led.ledOff();
   right_led.ledOff();
   GPIO.cleanup()

