#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
# import classes here.
from UpdateValues import *
from LegoMotor import LegoMotor

########################################
# experiment lego motor controlling    #
# file: LegoMotorControlling.py        #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 03/06/2016                     #
########################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
motor = LegoMotor(PORT_A)

BrickPiSetupSensors()									#Send the properties of sensors to BrickPi.  Set up the BrickPi.

# global valibales.
power = 70

startUpdateValues()

try:

   motor.resetTachoCount()
   motor.setSpeed(power)

   motor.forward(360)
   while(motor.isMoving()):
      time.sleep(0.5)

   print ("Cancel moving by pressing Strg + C")
   motor.backward()
   ct = time.time()
   while (True):
      time.sleep(0.1)
      motor.countTacho()
      if (time.time() - ct > 1.0):
         print(motor.getTachoCount())
         ct = time.time()

except KeyboardInterrupt:
   pass
finally:
   motor.stop()
   endUpdateValues()

