#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
from UpdateValues import *
# import classes here.
import RPi.GPIO as GPIO
from LegoTouchSensor import LegoTouchSensor
from Led import Led

############################################
# experiment lego touch sensor controlling #
# file: LegoTouchSensorControlling.py      #
# Author: Th. Kaffka, Cologne, Germany     #
# Date: 03/08/2016                         #
############################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
touch_nxt = LegoTouchSensor(PORT_1, TYPE_SENSOR_TOUCH_DEBOUNCE)
touch_ev3 = LegoTouchSensor(PORT_2, TYPE_SENSOR_EV3_TOUCH_0)
left_led = Led(12)
right_led = Led(13)

BrickPiSetupSensors()

# global valibales.
nxt_is_touched = False
ev3_is_touched = False
left_led_toggle = False
right_led_toggle = False

startUpdateValues()

try:

   print ("Cancel loop by pressing Strg + C")
   while (True):
      if (touch_nxt.isTouched() and (not nxt_is_touched)):
         nxt_is_touched = True
         left_led_toggle = not left_led_toggle
         if (left_led_toggle):
            left_led.ledOn();
         else:
            left_led.ledOff();
      elif (not touch_nxt.isTouched() and nxt_is_touched):
         nxt_is_touched = False
      elif (touch_ev3.isTouched() and (not ev3_is_touched)):
         ev3_is_touched = True
         right_led_toggle = not right_led_toggle
         if (right_led_toggle):
            right_led.ledOn();
         else:
            right_led.ledOff();
      elif (not touch_ev3.isTouched() and ev3_is_touched):
         ev3_is_touched = False
      time.sleep(0.1)
      
except KeyboardInterrupt:
   pass
finally:
   endUpdateValues()
   left_led.ledOff();
   right_led.ledOff();
   GPIO.cleanup()

