#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
from UpdateValues import *
# import classes here.
import RPi.GPIO as GPIO
from LegoUltraSonicSensor import LegoUltraSonicSensor
from Led import Led

#################################################
# experiment lego ultrasonic sensor controlling #
# file: LegoUltraSonicSensorControlling.py      #
# Author: Th. Kaffka, Cologne, Germany          #
# Date: 03/08/2016                              #
#################################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
sonic = LegoUltraSonicSensor(PORT_1)
left_led = Led(12)
right_led = Led(13)

BrickPiSetupSensors()

# global valibales.

startUpdateValues()

try:

   print ("Cancel loop by pressing Strg + C")
   while (True):
      time.sleep(0.1)
      dist = sonic.getDistance()
      if (dist < 10):
         left_led.ledOn()
         right_led.ledOn()
      elif (dist < 20):
         right_led.ledOn()
         left_led.ledOff()
      elif (dist < 30):
         left_led.ledOn()
         right_led.ledOff()
      else:
         left_led.ledOff()
         right_led.ledOff()
      
except KeyboardInterrupt:
   pass
finally:
   endUpdateValues()
   left_led.ledOff();
   right_led.ledOff();
   GPIO.cleanup()

