#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
from UpdateValues import *
# import classes here.
from LegoMotor import LegoMotor
from LegoVehicle import *

########################################
# experiment lego vehicle controlling  #
# file: LegoVehicleControlling.py      #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 03/06/2016                     #
########################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
motor_l = LegoMotor(PORT_A)
motor_r = LegoMotor(PORT_B)
vehicle = LegoVehicle(WHEEL_SIZE_EV3, 10.2, motor_l, motor_r)

BrickPiSetupSensors()									#Send the properties of sensors to BrickPi.  Set up the BrickPi.

startUpdateValues()

# global valibales.
power = 40

def wait(sec):
   ot = time.time()
   while (True):
      vehicle.countTacho()
#      print(vehicle.getLeftEncoder())
#      print(vehicle.getRightEncoder())
      time.sleep(0.1)
      if (time.time() - ot > sec):
         break

try:

   vehicle.setSpeed(power)

   vehicle.forward(10)
   while(vehicle.isMoving()):
      time.sleep(0.1)
   time.sleep(0.5)

   vehicle.backward(10)
   while(vehicle.isMoving()):
      time.sleep(0.1)
   time.sleep(0.5)

#   vehicle.backward()
#   wait(3.0)
#   vehicle.stop()
#   time.sleep(0.5)

#   vehicle.rotateLeft()
#   wait(3.0)
#   vehicle.stop()
#   time.sleep(0.5)

#   vehicle.rotateRight()
#   wait(3.0)
#   vehicle.stop()
#   time.sleep(0.5)

#   vehicle.rotate(360)
#   while(vehicle.isMoving()):
#      print(vehicle.getLeftEncoder())
#      print(vehicle.getRightEncoder())
#      time.sleep(0.1)
#   time.sleep(0.5)

#   vehicle.rotate(-360)
#   while(vehicle.isMoving()):
#      print(vehicle.getLeftEncoder())
#      print(vehicle.getRightEncoder())
#      time.sleep(0.1)
#   time.sleep(0.5)

except KeyboardInterrupt:
   pass
finally:
   vehicle.stop()
   endUpdateValues()

