#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
import RPi.GPIO as GPIO
from UpdateValues import *

# import classes here.
from PatternRecogn import PatternRecogn
from Led import Led
from LegoMotor import LegoMotor
from LegoTouchSensor import LegoTouchSensor

########################################
# experiment turret shooter            #
# file: RPiCameraTurretShooter.py      #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 05/12/2016                     #
########################################

BrickPiSetup()  										# setup the serial port for communication

# global valibales.
PIC_WIDTH = 60
PIC_HEIGHT = 44
GUN_POWER = 140
TURRET_POWER_FW = 20
TURRET_POWER_BK = 40

# define the hardware.
p_recog = PatternRecogn(PIC_WIDTH, PIC_HEIGHT)
left_led = Led(12)
right_led = Led(13)
motor_gun = LegoMotor(PORT_C)
motor_turret = LegoMotor(PORT_B)
park = LegoTouchSensor(PORT_4, TYPE_SENSOR_TOUCH_DEBOUNCE)

BrickPiSetupSensors()									#Send the properties of sensors to BrickPi.  Set up the BrickPi.

startUpdateValues()

##################
# signal to shoot.
def fireLed():
   left_led.ledOn();
   right_led.ledOn();
   time.sleep(0.1)
   left_led.ledOff();
   right_led.ledOff();
   time.sleep(0.1)
   left_led.ledOn();
   right_led.ledOn();
   time.sleep(0.3)
   left_led.ledOff();
   right_led.ledOff();
   time.sleep(0.1)

#####################
# shoot with the gun.
def shoot():
   fireLed()
   motor_gun.resetTachoCount()
   motor_gun.forward(540)
   while(motor_gun.isMoving()):
      time.sleep(0.01)
      
#######################################
# move the turret to the park position.
def gotoPark():
   motor_turret.setSpeed(TURRET_POWER_BK)
   motor_turret.backward()
   while(not park.isTouched()):
      time.sleep(0.01)
   motor_turret.stop()
   motor_turret.resetTachoCount()
   time.sleep(3.0)

try:

   mid_pic = PIC_WIDTH / 2 + 10
   motor_gun.setSpeed(GUN_POWER)

   while (True):

      # start a shooting session.
      while (not park.isTouched()):
         time.sleep(0.1)
      time.sleep(1.5)

      gotoPark()

      # start search session.      
      motor_turret.setSpeed(TURRET_POWER_FW)
      motor_turret.forward()
      time.sleep(0.5)
      while(motor_turret.getEncoderDegrees() < 220 and (not park.isTouched())):
         motor_turret.forward()
         rect = p_recog.getMaxRect()
         if (rect == (0, 0, 0, 0)):
            print("not recognized")
            time.sleep(0.1)
            continue
         motor_turret.stop()
         time.sleep(0.1)
         mid_rect = rect[0] + (rect[2] - rect[0]) / 2
         if (mid_pic - 5 <= mid_rect and mid_pic + 5 >= mid_rect):
            shoot()
            break
         print(mid_rect)
         time.sleep(0.1)

      motor_turret.stop()

except KeyboardInterrupt:
   pass
finally:
   left_led.ledOff();
   right_led.ledOff();
   endUpdateValues()
   GPIO.cleanup()
