#!/usr/bin/python
import sys
sys.path.append("/home/pi/Ae/Python/Interface")
sys.path.append("/home/pi/Desktop/BrickPi_Python/Sensor_Examples")
from BrickPi import *   								#import BrickPi.py file to use BrickPi operations
import time
from UpdateValues import *
# import classes here.
from LegoMotor import LegoMotor
from LegoVehicle import *

########################################
# prorgam: move the platonian areas    #
# file: Platon.py                      #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 03/19/2016                     #
########################################

BrickPiSetup()  										# setup the serial port for communication

# define the hardware.
motor_l = LegoMotor(PORT_B)
motor_r = LegoMotor(PORT_C)
vehicle = LegoVehicle(WHEEL_SIZE_EV3, 15.5, motor_l, motor_r)

BrickPiSetupSensors()									#Send the properties of sensors to BrickPi.  Set up the BrickPi.

# global valibales.
TRIANGLE = 3
QUARDER = 4
PENTAGON = 5

power = 50
figure = 0
count = 0
angle = 0
distance = 0

startUpdateValues()

try:
   time.sleep(20)
   vehicle.setSpeed(power)

   while (True):
      if (count ==  0):
         if (figure == 0):
            figure = TRIANGLE
         elif (figure == TRIANGLE):
            figure = QUARDER
         elif (figure == QUARDER):
            figure = PENTAGON
         else:
            break;
         count = figure
         angle = 360 / figure
         distance = 180 / figure
         
      vehicle.backward(distance)
      while(vehicle.isMoving()):
         time.sleep(0.1)
      vehicle.rotate(angle)
      while(vehicle.isMoving()):
         time.sleep(0.1)
      count -= 1

finally:
   vehicle.stop()
   endUpdateValues()
